]> git.cworth.org Git - lmno-server/blob - test
Add new failing test case: Inactive players shouldn't impede phase advance
[lmno-server] / test
1 #!/bin/bash
2
3 # Arrange for some cleanup to be executed if the user interrupts the
4 # test sutie (for example, by pressing ControlC at the controlling
5 # terminal).
6 cleanup_and_report() {
7     empathy_deactivate_all >/dev/null 2>&1
8     TEST_REPORT
9     exit $?
10 }
11 trap cleanup_and_report INT
12
13 usage ()
14 {
15     echo "Usage:$0 <URL-to-test>"
16 }
17
18 if [ $# -lt 1 ]; then
19     echo "Error: No test URL given." >&2
20     echo "" >&2
21     usage >&2
22     exit 1
23 fi
24
25 URL=$1
26 CURL="curl --silent --show-error"
27
28 _TEST_SECTION()
29 {
30     echo ""
31     echo $1
32     echo $1 | sed -e "s/./$2/g"
33 }
34
35 TEST_SECTION()
36 {
37     _TEST_SECTION "$1" =
38 }
39
40 TEST_SUBSECTION()
41 {
42     _TEST_SECTION "$1" -
43 }
44
45 TEST()
46 {
47     printf "    $1"
48     printf "%*s" $(( 52 - ${#1} )) | tr ' ' '.'
49     (( tests_total++ )) || true
50 }
51
52 # Result of test depends on the exit status of last command
53 TEST_END()
54 {
55     if [ $? -eq 0 ]; then
56         echo -n "OK"
57     else
58         (( tests_failed++ )) || true
59         echo -n "FAIL"
60     fi
61
62     # If we got an argument, append it after test result
63     if [ -n "$1" ]; then
64         echo " $1"
65     else
66         echo ""
67     fi
68 }
69
70 # Print report of all previous test results
71 TEST_REPORT()
72 {
73     echo ""
74     echo ""
75     echo "Test Report"
76     echo "==========="
77
78     if [ "$tests_failed" == "" ]; then
79         echo "All $tests_total tests passed."
80         echo ""
81         return 0
82     else
83         echo "$tests_failed of $tests_total tests failed."
84         echo ""
85         return 1
86     fi
87 }
88
89 # Does a string contain a regular expression pattern
90 #
91 # Example:
92 #
93 #    contains "All's well that ends well" "s.well"
94 contains()
95 {
96     grep -q "$2" <<< $1
97 }
98
99 # POST to a URL endpoint with optional JSON data
100 #
101 # Usage:
102 #
103 # curl_post <ENDPOINT> [data] [CURL_OPTIONS]
104 curl_post()
105 {
106     $CURL ${3:-} -X POST ${2:+-H 'Content-Type: application/json' -d "$2"} $URL/$1
107 }
108
109 # POST to a URL endpoint with optional JSON data using a cookie
110 #
111 # Usage:
112 #
113 # curl_post_cookie <name> <ENDPOINT> [data] [CURL_OPTIONS]
114 #
115 # Where <name> is a string for which there is a defined variable
116 # named ${name}_cookie which in turn holds a value that is a filename
117 # of a valid cookie
118 curl_post_cookie()
119 {
120     cookie=${1}_cookie
121     curl_post $2 "${3:-}" "-b ${!cookie} ${4:-}"
122 }
123
124 # PUT to a URL endpoint with optional JSON data
125 #
126 # Usage:
127 #
128 # curl_post <ENDPOINT> [data] [CURL_OPTIONS]
129 curl_put()
130 {
131     $CURL ${3:-} -X PUT ${2:+-H 'Content-Type: application/json' -d "$2"} $URL/$1
132 }
133
134 # GET from a URL endpoint
135 #
136 # Usage:
137 #
138 # curl_get <ENDPOINT> [CURL_OPTIONS]
139 curl_get()
140 {
141     $CURL ${2:-} $URL/$1
142 }
143
144 # GET from a URL endpoint using a cookie
145 #
146 # Usage:
147 #
148 # curl_get_cookie <name> <ENDPOINT> [CURL_OPTIONS]
149 #
150 # Where <name> is a string for which there is a defined variable
151 # named ${name}_cookie which in turn holds a value that is a filename
152 # of a valid cookie
153 curl_get_cookie()
154 {
155     cookie=${1}_cookie
156     curl_get $2 "-b ${!cookie} ${3:-}"
157 }
158
159 # Create a new game of the specified engine type
160 #
161 # Usage:
162 #
163 # new_game <ENGINE>
164 new_game()
165 {
166     curl_post new/$1 | jq -r .
167 }
168
169 TEST_SECTION "LMNO (super-site for games)"
170
171 TEST_SUBSECTION "Testing home page"
172 home_page=$($CURL $URL)
173
174 TEST "Contains 'Join Game'"
175 contains "$home_page" "Join Game"
176 TEST_END
177
178 TEST "Contains 'Host a new game'"
179 contains "$home_page" "Host a new game"
180 TEST_END
181
182 TEST_SUBSECTION "Creating some new games"
183
184 TEST "Empires"
185 empires_game_id=$(new_game empires)
186 test "$empires_game_id" != ""
187 TEST_END $empires_game_id
188
189 TEST "Tic Tac Toe"
190 tictactoe_game_id=$(new_game tictactoe)
191 test "$tictactoe_game_id" != ""
192 TEST_END $tictactoe_game_id
193
194 TEST_SUBSECTION "Test redirects"
195
196 TEST "Redirect of /GAMEID at top level"
197 redirect=$(curl_get $empires_game_id)
198 test "$redirect" = "Moved Permanently. Redirecting to /empires/$empires_game_id/"
199 TEST_END
200
201 TEST "Redirect of lowercase /gameid at top level"
202 empires_game_id_lower=$(tr '[:upper:]' '[:lower:]' <<< $empires_game_id)
203 redirect=$(curl_get $empires_game_id_lower)
204 test "$redirect" = "Moved Permanently. Redirecting to /$empires_game_id/"
205 TEST_END
206
207 TEST "Redirect of lowercase /empires/gameid"
208 redirect=$(curl_get empires/$empires_game_id_lower)
209 test "$redirect" = "Moved Permanently. Redirecting to /empires/$empires_game_id/"
210 TEST_END
211
212 TEST_SECTION "Empires game"
213
214 empires_game_path=empires/$empires_game_id
215
216 TEST_SUBSECTION "Empires game /register"
217
218 empires_register()
219 {
220     curl_post $empires_game_path/register "{\"name\": \"$1\", \"character\": \"$2\"}"
221 }
222
223 empires_players_string()
224 {
225     curl_get $empires_game_path/players | jq -r .[].name | tr '\n' ','
226 }
227
228 empires_characters_string()
229 {
230     curl_get $empires_game_path/characters | jq -r .[] | tr '\n' ','
231 }
232
233 TEST "Registering a player returns an ID"
234 carl_id=$(empires_register Carl "Bugs Bunny" | jq -r .)
235 test "$carl_id" = "1"
236 TEST_END
237
238 TEST "Registering several more players"
239 empires_register Richard "Bob Hope" > /dev/null
240 empires_register Kevin "Elvis Presley" > /dev/null
241 empires_register Stacy Phineas > /dev/null
242 empires_register David "Red Power Ranger" > /dev/null
243 empires_register Nancy "Audrey Hepburn" > /dev/null
244 bogus_id=$(empires_register Bogus "Mr. Bogus")
245 TEST_END
246
247 TEST 'Verify complete players list (with "Bogus")'
248 players=$(empires_players_string)
249 test "$players" = "Carl,Richard,Kevin,Stacy,David,Nancy,Bogus,"
250 TEST_END
251
252 TEST 'Verify complete players list (with "Mr. Bogus")'
253 characters=$(empires_characters_string)
254 test "$characters" = "Bugs Bunny,Bob Hope,Elvis Presley,Phineas,Red Power Ranger,Audrey Hepburn,Mr. Bogus,"
255 TEST_END
256
257 TEST_SUBSECTION "Empires game /deregister"
258
259 empires_deregister()
260 {
261     curl_post $empires_game_path/deregister/$1
262 }
263
264 TEST "Removing the bogus player"
265 empires_deregister $bogus_id
266 TEST_END
267
268 TEST 'Verify modified players list (w/o "Bogus")"'
269 players=$(empires_players_string)
270 test "$players" = "Carl,Richard,Kevin,Stacy,David,Nancy,"
271 TEST_END
272
273 TEST 'Verify modified characters list (w/o "Mr. Bogus")'
274 characters=$(empires_characters_string)
275 test "$characters" = "Bugs Bunny,Bob Hope,Elvis Presley,Phineas,Red Power Ranger,Audrey Hepburn,"
276 TEST_END
277
278 TEST_SUBSECTION "Empires game /capture"
279
280 empires_capture()
281 {
282     curl_post $empires_game_path/capture/$1/$2
283 }
284
285 empires_empires_string()
286 {
287     # Get empires as a compact string (much more compact than JSON)
288     curl_get $empires_game_path/empires | jq -c '.[] | [.id,.captures]' | tr '\n' ','
289 }
290
291 TEST "Verify empires before any captures"
292 empires=$(empires_empires_string)
293 test "$empires" = "[1,[]],[2,[]],[3,[]],[4,[]],[5,[]],[6,[]],"
294 TEST_END
295
296 TEST "Perform some captures"
297 empires_capture 1 2
298 empires_capture 3 5
299 empires_capture 4 6
300 empires_capture 3 4
301 TEST_END
302
303 TEST "Verify empires after captures"
304 empires=$(empires_empires_string)
305 test "$empires" = "[1,[2]],[2,[]],[3,[5,4]],[4,[6]],[5,[]],[6,[]],"
306 TEST_END
307
308 TEST_SUBSECTION "Empires game /liberate"
309
310 empires_liberate()
311 {
312     curl_post $empires_game_path/liberate/$1
313 }
314
315 TEST "Liberate a player"
316 empires_liberate 2
317 TEST_END
318
319 TEST "Verify empires after liberate"
320 empires=$(empires_empires_string)
321 test "$empires" = "[1,[]],[2,[]],[3,[5,4]],[4,[6]],[5,[]],[6,[]],"
322 TEST_END
323
324 TEST_SUBSECTION "Empires game /reset"
325
326 empires_reset()
327 {
328     curl_post $empires_game_path/reset
329 }
330
331 TEST "Reset the game"
332 empires_reset
333 TEST_END
334
335 TEST "Verify players is now empty"
336 players=$(empires_players_string)
337 test "$players" = ""
338 TEST_END
339
340 TEST_SECTION "Tic Tac Toe game"
341
342 tictactoe_game_path=tictactoe/$tictactoe_game_id
343
344 tictactoe_profile()
345 {
346     curl_put /profile "{ \"nickname\": \"$1\" }" "-c .cookie-tictactoe"
347 }
348
349 tictactoe_move()
350 {
351     curl_post $tictactoe_game_path/move "{ \"move\": $1 }" "-b .cookie-tictactoe"
352 }
353
354 tictactoe_player_info()
355 {
356     curl_get $tictactoe_game_path/events  "-m 0.1 -b .cookie-tictactoe" 2>&1 \
357         | grep player-info -A 1 \
358         | grep ^data
359 }
360
361 tictactoe_player_name()
362 {
363     curl_put $tictactoe_game_path/player "{ \"name\": \"$1\" }" "-b .cookie-tictactoe"
364 }
365
366 tictactoe_player_team()
367 {
368     curl_put $tictactoe_game_path/player "{ \"team\": \"$1\" }" "-b .cookie-tictactoe"
369 }
370
371 TEST_SUBSECTION "Tic Tac Toe player-info"
372
373 TEST "Hit LMNO /profile to set name to 'curl'"
374 tictactoe_profile curl
375 TEST_END
376
377 TEST "Verify player-info event reports 'curl' name"
378 result=$(tictactoe_player_info)
379 test "$result" = 'data: {"id":1,"name":"curl","team":""}'
380 TEST_END
381
382 TEST_SUBSECTION "Tic Tac Toe /player"
383
384 TEST "Change name to 'newname'"
385 tictactoe_player_name newname
386 result=$(tictactoe_player_info)
387 test "$result" = 'data: {"id":1,"name":"newname","team":""}'
388 TEST_END
389
390 TEST "Change team to 'X'"
391 tictactoe_player_team X
392 result=$(tictactoe_player_info)
393 test "$result" = 'data: {"id":1,"name":"newname","team":"X"}'
394 TEST_END
395
396 TEST "Change team to 'O'"
397 tictactoe_player_team O
398 result=$(tictactoe_player_info)
399 test "$result" = 'data: {"id":1,"name":"newname","team":"O"}'
400 TEST_END
401
402 TEST "Verify cannot change team to 'Z'"
403 tictactoe_player_team Z
404 result=$(tictactoe_player_info)
405 test "$result" = 'data: {"id":1,"name":"newname","team":"O"}'
406 TEST_END
407
408 TEST "Leave current team"
409 tictactoe_player_team ""
410 result=$(tictactoe_player_info)
411 test "$result" = 'data: {"id":1,"name":"newname","team":""}'
412 TEST_END
413
414 TEST_SUBSECTION "Tic Tac Toe /move"
415
416 TEST "First move doesn't require a team"
417 result=$(tictactoe_move 0)
418 test "$result" = '{"legal":true}'
419 TEST_END
420
421 TEST "Second move does require a team"
422 result=$(tictactoe_move 4)
423 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
424 TEST_END
425
426 TEST "Illegal to move when it's not your turn"
427 tictactoe_player_team X
428 result=$(tictactoe_move 4)
429 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
430 TEST_END
431
432 TEST "Legal move to center square"
433 tictactoe_player_team O
434 result=$(tictactoe_move 4)
435 test "$result" = '{"legal":true}'
436 TEST_END
437
438 TEST "Move to center square again is now illegal"
439 tictactoe_player_team X
440 result=$(tictactoe_move 4)
441 test "$result" = '{"legal":false,"message":"Square is already occupied"}'
442 TEST_END
443
444 TEST_SECTION "Empathy game"
445
446 TEST_SUBSECTION "Create a game and register 3 players"
447
448 TEST "Create the game"
449 empathy_game_id=$(new_game empathy)
450 test "$empathy_game_id" != ""
451 TEST_END $empathy_game_id
452
453 empathy_game_path=empathy/$empathy_game_id
454
455 # Usage: empathy_get <player_name> <endpoint> [curl_options]
456 empathy_get()
457 {
458     curl_get_cookie $1 $empathy_game_path/$2 "${3:-}"
459 }
460
461 # Usage: empathy_post <player_name> <endpoint> [data]
462 empathy_post()
463 {
464     curl_post_cookie $1 $empathy_game_path/$2 "${3:-}"
465 }
466
467 # Given a player name as $1 (eg. "empathy_player_activate alice") set both
468 # $1_cookie and $1_pid (that is $alice_cookie and $alice_pid) to
469 # a filename containing a cookie and the PID of a running event-streaming
470 # process.
471 empathy_player_activate()
472 {
473     player="$1"
474     player_cookie=${player}_cookie
475     player_pid=${player}_pid
476
477     eval ${player_cookie}=".cookie-empathy-$player"
478     curl_put /profile "{ \"nickname\": \"$player\" }" "-c ${!player_cookie}"
479     empathy_get $player events >/dev/null 2>&1 &
480     eval ${player_pid}=$!
481     empathy_players+=($player)
482 }
483
484 # Usage: empathy_player_deactivate <player_name>
485 empathy_player_deactivate()
486 {
487     player="$1"
488     player_pid=${player}_pid
489     if [ "${!player_pid}" != "" ]; then
490         pkill -P ${!player_pid}
491     fi
492     eval ${player_pid}=""
493 }
494
495 empathy_deactivate_all()
496 {
497     for player in ${empathy_players[*]}; do
498         empathy_player_deactivate $player
499     done
500 }
501
502 # Pulls a single named event out of the empathy event stream
503 #
504 # Usage: empathy_get_event <player_name> <event_name>
505 empathy_get_event()
506 {
507     empathy_get $1 events "-m 0.1" 2>&1 \
508         | grep "^event: $2" -A 1 \
509         | grep ^data: \
510         | sed -e 's,^data: *,,'
511 }
512
513 # Usage: empathy_player_name <player_name>
514 empathy_player_name()
515 {
516     empathy_get_event $1 player-info | jq -r .name
517 }
518
519 TEST "Set 'alice' in session"
520 empathy_player_activate alice
521 test "$alice_cookie" = ".cookie-empathy-alice"
522 TEST_END
523
524 TEST "Register alice and verify name"
525 result=$(empathy_player_name alice)
526 test "$result" = "alice"
527 TEST_END
528
529 TEST "Register bob"
530 empathy_player_activate bob
531 result=$(empathy_player_name bob)
532 test "$result" = "bob"
533 TEST_END
534
535 TEST "Register charlie"
536 empathy_player_activate charlie
537 result=$(empathy_player_name charlie)
538 test "$result" = "charlie"
539 TEST_END
540
541 TEST_SUBSECTION "Category selection"
542
543 # Usage: empathy_submit_prompt <player_name> <count> <prompt_string>
544 empathy_submit_prompt()
545 {
546     empathy_post $1 prompts "{ \"items\": $2, \"prompt\": \"$3\"}"
547 }
548
549 TEST "Huge numbers are rejected"
550 result=$(empathy_submit_prompt alice 10000 "10,000 Maniacs")
551 test "$result" = '{"valid":false,"message":"Maximum number of items is 20"}'
552 TEST_END
553
554 TEST "Submit a category"
555 prompt_id=$(empathy_submit_prompt alice 4 "4 things on a beach" | jq .id)
556 test "$prompt_id" = "1"
557 TEST_END
558
559 # Usage: empathy_vote <player_name> <prompt_id>
560 empathy_vote()
561 {
562     empathy_post $1 vote/$2
563 }
564
565 TEST "Vote on this category"
566 empathy_vote alice $prompt_id
567 test "$?" = "0"
568 TEST_END
569
570 # Usage: empathy_start <player_name> <prompt_id>
571 empathy_start()
572 {
573     empathy_post $1 start/$2
574 }
575
576 TEST "Start the game with this category"
577 empathy_start alice $prompt_id
578 test "$?" = "0"
579 TEST_END
580
581 # Usage: empathy_answer <player_name> <prompt_id> <answers_string>
582 empathy_answer()
583 {
584     empathy_post $1 answer/$2 "{ \"answers\": [$3]}"
585 }
586
587 TEST_SUBSECTION "Submitting answers"
588
589 TEST "Submit from a non-player fails"
590 bogus_cookie=/dev/null
591 result=$(empathy_answer bogus $prompt_id '"Sun", "Sand", "Water", "People"')
592 test "$result" = '{"valid":false,"message":"Player not found"}'
593 TEST_END
594
595 TEST "Submit from alice succeeds"
596 result=$(empathy_answer alice $prompt_id '"sun", "sand", "water", "people"')
597 test "$result" = '{"valid":true}'
598 TEST_END
599
600 TEST "Submit from bob succeeds"
601 result=$(empathy_answer bob $prompt_id '"sand", "sands", "SunLight", "towels"')
602 test "$result" = '{"valid":true}'
603 TEST_END
604
605 # Usage: empathy_ambiguities <player_name>
606 empathy_ambiguities()
607 {
608     empathy_get_event $1 game-state | jq .ambiguities
609 }
610
611 TEST "Judging hasn't started with player unsubmitted"
612 result=$(echo $(empathy_ambiguities alice))
613 test "$result" = "null"
614 TEST_END
615
616 TEST "Submit from charlie succeeds"
617 result=$(empathy_answer charlie $prompt_id '"SunShine", "Grains of Sand", "wafer", "people"')
618 test "$result" = '{"valid":true}'
619 TEST_END
620
621 TEST_SUBSECTION "Transition from answering to judging (no voting needed)"
622
623 TEST "Judging already started"
624 result=$(echo $(empathy_ambiguities alice))
625 test "$result" != "null"
626 TEST_END
627
628 TEST_SUBSECTION "Judging answers"
629
630 # Usage: empathy_ambiguities_list <player_name>
631 empathy_ambiguities_list()
632 {
633     empathy_get_event $1 game-state | jq .ambiguities[]
634 }
635
636 TEST "Received all unique words"
637 # echo here is to strip newlines
638 result=$(echo $(empathy_ambiguities_list alice))
639 test "$result" = '"Grains of Sand" "people" "sand" "sands" "sun" "SunLight" "SunShine" "towels" "wafer" "water"'
640 TEST_END
641
642 # Usage: empathy_judged <player_name> <prompt_id> <word_groups_string>
643 empathy_judged()
644 {
645     empathy_post $1 judged/$2 "{ \"word_groups\": $3}"
646 }
647
648 TEST "Submit word groups from alice"
649 result=$(empathy_judged alice $prompt_id '[["sun","SunLight","SunShine"],["sand","sands","Grains of Sand"],["water","wafer"]]')
650 test "$result" = '{"valid":true}'
651 TEST_END
652
653 TEST "Submit word groups from bob"
654 result=$(empathy_judged bob $prompt_id '[["sands","grains of sand"],["water","wafer"]]')
655 test "$result" = '{"valid":true}'
656 TEST_END
657
658 # Usage: empathy_scores <player_name>
659 empathy_scores()
660 {
661     empathy_get_event $1 game-state | jq .scores
662 }
663
664 TEST "Scoring hasn't started with player unsubmitted"
665 result=$(echo $(empathy_scores alice))
666 test "$result" = "null"
667 TEST_END
668
669 TEST "Submit word groups from charlie"
670 result=$(empathy_judged charlie $prompt_id '[["SunLight","SunShine"],["sand","Grains of Sand"]]')
671 test "$result" = '{"valid":true}'
672 TEST_END
673
674 TEST_SUBSECTION "Transition from judging to scoring (no voting needed)"
675
676 TEST "Scoring already started"
677 result=$(echo $(empathy_scores alice))
678 test "$result" != "null"
679 TEST_END
680
681 # Usage: empathy_scores_names_numbers <player_name>
682 empathy_scores_names_numbers()
683 {
684     empathy_get_event $1 game-state | jq '.scores.scores[]|.player,.score'
685 }
686
687 TEST_SUBSECTION "Scoring"
688
689 TEST "Verify final scores as expected"
690 # echo here is to strip newlines
691 result=$(echo $(empathy_scores_names_numbers alice))
692 test "$result" = '"charlie" 9 "alice" 8 "bob" 6'
693 TEST_END
694
695 # Usage: empathy_words_submitted <player_name>
696 empathy_words_submitted()
697 {
698     empathy_get_event $1 game-state | jq '.scores.words[].word'
699 }
700
701 TEST "Verify final list of words submitted"
702 # echo here is to strip newlines
703 result=$(echo $(empathy_words_submitted alice))
704 test "$result" = '"Grains of Sand/sand/sands" "SunLight/SunShine" "wafer/water" "people" "sun" "towels"'
705 TEST_END
706
707 TEST_SUBSECTION "New game (using voting to advance phases)"
708
709 empathy_reset()
710 {
711     curl_post $empathy_game_path/reset
712 }
713
714 TEST "Any post to /reset resets the game"
715 empathy_reset
716 test "$?" = "0"
717 TEST_END
718
719 TEST "Verify scoring is over"
720 result=$(echo $(empathy_scores alice))
721 test "$result" = "null"
722 TEST_END
723
724 # Usage: empathy_answering <player_name> <prompt_id>
725 empathy_answering()
726 {
727     empathy_post $1 answering/$2
728 }
729
730 TEST "Start 4-player game, 3 submissions"
731 empathy_player_activate dale
732 result=$(empathy_player_name dale)
733 test "$result" = "dale"
734 prompt_id=$(empathy_submit_prompt alice 4 "3 little words" | jq .id)
735 empathy_start alice $prompt_id
736 empathy_answer alice   $prompt_id '"I",    "love", "you"' >/dev/null
737 empathy_answer bob     $prompt_id '"I",    "love", "food"' >/dev/null
738 empathy_answer charlie $prompt_id '"food", "is",   "good"' >/dev/null
739 result=$(empathy_answering dale $prompt_id)
740 test "$result" = '{"valid":true}'
741 TEST_END
742
743 TEST "Judging hasn't started with player unsubmitted"
744 result=$(echo $(empathy_ambiguities alice))
745 test "$result" = "null"
746 TEST_END
747
748 # Usage: empathy_end_answers <player_name> <prompt_id>
749 empathy_end_answers()
750 {
751     empathy_post $1 end-answers/$2
752 }
753
754 TEST "Minority of players vote to end answering"
755 empathy_end_answers alice $prompt_id
756 empathy_end_answers bob $prompt_id
757 test "$?" = "0"
758 TEST_END
759
760 TEST "Judging still hasn't started"
761 result=$(echo $(empathy_ambiguities alice))
762 test "$result" = "null"
763 TEST_END
764
765 TEST "Majority of players vote to end answering"
766 empathy_end_answers charlie $prompt_id
767 test "$?" = "0"
768 TEST_END
769
770 TEST "Judging has now started"
771 result=$(echo $(empathy_ambiguities alice))
772 test "$result" != "null"
773 TEST_END
774
775 # Usage: empathy_players_judging <player_name>
776 empathy_players_judging()
777 {
778     empathy_get_event $1 game-state | jq .players_judging[]
779 }
780
781 TEST "Verify active players listed as judging"
782 # echo here is to strip newlines
783 result=$(echo $(empathy_players_judging alice))
784 test "$result" = '"alice" "bob" "charlie"'
785 TEST_END
786
787 TEST "Submit word groups from majority"
788 empathy_judged alice $prompt_id '[]' >/dev/null
789 result=$(empathy_judged bob $prompt_id '[]')
790 test "$result" = '{"valid":true}'
791 TEST_END
792
793 TEST "Scoring hasn't started with player unsubmitted"
794 result=$(echo $(empathy_scores alice))
795 test "$result" = "null"
796 TEST_END
797
798 # Usage: empathy_end_judging <player_name> <prompt_id>
799 empathy_end_judging()
800 {
801     empathy_post $1 end-judging/$2
802 }
803
804 TEST "Minority of players vote to end judging"
805 empathy_end_judging alice $prompt_id
806 test "$?" = "0"
807 TEST_END
808
809 TEST "Scoring still hasn't started"
810 result=$(echo $(empathy_scores alice))
811 test "$result" = "null"
812 TEST_END
813
814 TEST "Majority of players vote to end judging"
815 empathy_end_judging bob $prompt_id
816 test "$?" = "0"
817 TEST_END
818
819 TEST "Scoring has now started"
820 result=$(echo $(empathy_scores alice))
821 test "$result" != "null"
822 TEST_END
823
824 TEST_SUBSECTION "New game (no voting needed when all answered players judge)"
825
826 TEST "Start 4-player game, 3 submissions"
827 empathy_reset
828 prompt_id=$(empathy_submit_prompt alice 4 "1 truth or dare" | jq .id)
829 empathy_start alice $prompt_id
830 empathy_answer alice   $prompt_id '"truth"' >/dev/null
831 empathy_answer bob     $prompt_id '"truth"' >/dev/null
832 empathy_answer charlie $prompt_id '"dare"' >/dev/null
833 empathy_end_answers alice $prompt_id
834 empathy_end_answers bob $prompt_id
835 empathy_end_answers charlie $prompt_id
836 test "$?" = "0"
837 TEST_END
838
839 TEST "Submit word groups from 2 players"
840 empathy_judged alice $prompt_id '[]' >/dev/null
841 result=$(empathy_judged bob $prompt_id '[]')
842 test "$result" = '{"valid":true}'
843 TEST_END
844
845 TEST "Scoring hasn't started with player unsubmitted"
846 result=$(echo $(empathy_scores alice))
847 test "$result" = "null"
848 TEST_END
849
850 TEST "Submit word groups from last answering player"
851 result=$(empathy_judged charlie $prompt_id '[]')
852 test "$result" = '{"valid":true}'
853 TEST_END
854
855 TEST "Scoring has now started"
856 result=$(echo $(empathy_scores alice))
857 test "$result" != "null"
858 TEST_END
859
860 TEST_SUBSECTION "Non players don't affect judging requirements"
861
862 TEST "Start 2-player game with 6 registered players"
863 empathy_reset
864 empathy_player_activate eric
865 empathy_player_activate fred
866 prompt_id=$(empathy_submit_prompt alice 4 "1 truth or dare" | jq .id)
867 empathy_start alice $prompt_id
868 empathy_answer alice $prompt_id '"truth"' >/dev/null
869 empathy_answer bob   $prompt_id '"true"' >/dev/null
870 empathy_end_answers alice $prompt_id
871 empathy_end_answers bob $prompt_id
872 test "$?" = "0"
873 TEST_END
874
875 TEST "1 player votes for a match"
876 empathy_judged alice $prompt_id '[["truth","true"]]' >/dev/null
877 result=$(empathy_judged bob $prompt_id '[]')
878 test "$result" = '{"valid":true}'
879 TEST_END
880
881 TEST "Verify the match passed the vote"
882 # echo here is to strip newlines
883 result=$(echo $(empathy_scores_names_numbers alice))
884 test "$result" = '"alice" 2 "bob" 2 "charlie" 0 "dale" 0 "eric" 0 "fred" 0'
885 TEST_END
886
887 echo ""
888 echo "NOTE: Slow tests ahead!"
889 echo "If you are impatient and somehow \"know\" you don't care about the"
890 echo "tests below then you can interrupt the test suite with Control-C"
891 echo "to get a summary report on the tests that have already been run."
892
893 TEST_SUBSECTION "Inactive players don't appear in scores"
894
895 TEST "Start 2-player game with 6 registered players"
896 empathy_reset
897 prompt_id=$(empathy_submit_prompt alice 4 "1 best pet" | jq .id)
898 empathy_start alice $prompt_id
899 empathy_answer alice $prompt_id '"cats"' >/dev/null
900 empathy_answer bob   $prompt_id '"dogs"' >/dev/null
901 empathy_end_answers alice $prompt_id
902 empathy_end_answers bob $prompt_id
903 test "$?" = "0"
904 TEST_END
905
906 TEST "Deactivate 3 players"
907 empathy_player_deactivate dale
908 empathy_player_deactivate eric
909 empathy_player_deactivate fred
910 sleep 30
911 test "$?" = "0"
912 TEST_END
913
914 TEST "Finish game with 2 active players"
915 empathy_judged alice $prompt_id '[]' >/dev/null
916 result=$(empathy_judged bob $prompt_id '[]')
917 test "$result" = '{"valid":true}'
918 TEST_END
919
920 TEST "Verify scores don't include inactive players"
921 # echo here is to strip newlines
922 result=$(echo $(empathy_scores_names_numbers alice))
923 test "$result" = '"alice" 1 "bob" 1 "charlie" 0'
924 TEST_END
925
926 TEST_SUBSECTION "Deactivated players don't block future game phase advances"
927
928 TEST "New 3-player game, 2 submit right away"
929 empathy_reset
930 prompt_id=$(empathy_submit_prompt charlie 4 "2 legit 2 quit" | jq .id)
931 empathy_start alice $prompt_id
932 empathy_answer alice $prompt_id '"what", "gives?"' >/dev/null
933 empathy_answer bob   $prompt_id '"so", "confused"' >/dev/null
934 test "$?" = "0"
935 TEST_END
936
937 TEST "Judging hasn't started with player unsubmitted"
938 result=$(echo $(empathy_ambiguities alice))
939 test "$result" = "null"
940 TEST_END
941
942 TEST "Final active player submits"
943 result=$(empathy_answer charlie $prompt_id '"best", "category"')
944 test "$result" = '{"valid":true}'
945 TEST_END
946
947 TEST "Judging has started (don't need inactive players)"
948 result=$(echo $(empathy_ambiguities alice))
949 test "$result" != "null"
950 TEST_END
951
952 TEST "Submit word groups from 2 players"
953 empathy_judged alice $prompt_id '[]' >/dev/null
954 result=$(empathy_judged bob $prompt_id '[]')
955 test "$result" = '{"valid":true}'
956 TEST_END
957
958 TEST "Scoring hasn't started with player unsubmitted"
959 result=$(echo $(empathy_scores alice))
960 test "$result" = "null"
961 TEST_END
962
963 TEST "Submit word groups from last answering player"
964 result=$(empathy_judged charlie $prompt_id '[]')
965 test "$result" = '{"valid":true}'
966 TEST_END
967
968 TEST "Scoring has now started"
969 result=$(echo $(empathy_scores alice))
970 test "$result" != "null"
971 TEST_END
972
973 cleanup_and_report